(function (blocks, i18n, element, blockEditor) {
    var el = element.createElement;
    var __ = i18n.__;
    var useBlockProps = blockEditor.useBlockProps;

    var blockStyle = {
        backgroundColor: '#f8f9fa',
        color: '#000',
        padding: '20px',
        border: '1px solid #dee2e6',
        borderRadius: '10px',
        boxShadow: '0 0.5rem 1rem rgb(0 0 0 / 15%)',
    };

    blocks.registerBlockType('getsoapy/quote', {
        title: 'Quote',
        name: 'getsoapy/quote',
        category: 'getsoapy',
        icon: 'feedback',
        edit: function () {
            return el(
                'div',
                useBlockProps({ style: blockStyle }),
                [
                    el(
                        'h3',
                        null,
                        'Request a quote'
                    ),
                    el(
                        'p',
                        null,
                        'The getSoapy quote widget will show here.'
                    )
                ]
            );
        },
        save: function () {
            return el(
                'p',
                useBlockProps.save({ id: 'getsoapy-quote', className: 'getsoapy' }),
                __('getSoapy Quote widget. Javascript is required.', 'getsoapy')
            );
        },
    });

    blocks.registerBlockType('getsoapy/payment', {
        title: 'Payment',
        name: 'getsoapy/payment',
        category: 'getsoapy',
        icon: 'money-alt',
        edit: function () {
            return el(
                'div',
                useBlockProps({ style: blockStyle }),
                [
                    el(
                        'h3',
                        null,
                        'Pay now'
                    ),
                    el(
                        'p',
                        null,
                        'The getSoapy payment widget will show here.'
                    )
                ]
            );
        },
        save: function () {
            return el(
                'p',
                useBlockProps.save({ id: 'getsoapy-pay', className: 'getsoapy' }),
                __('getSoapy Payment widget. Javascript is required.', 'getsoapy')
            );
        },
    });

    blocks.registerBlockType('getsoapy/portal', {
        title: 'Contact Portal',
        name: 'getsoapy/portal',
        category: 'getsoapy',
        icon: 'admin-users',
        edit: function () {
            return el(
                'div',
                useBlockProps({ style: blockStyle }),
                [
                    el(
                        'h3',
                        null,
                        'Customer Portal'
                    ),
                    el(
                        'p',
                        null,
                        'The getSoapy customer portal will show here.'
                    )
                ]
            );
        },
        save: function () {
            return el(
                'p',
                useBlockProps.save({ id: 'getsoapy-portal', className: 'getsoapy' }),
                __('getSoapy Payment widget. Javascript is required.', 'getsoapy')
            );
        },
    });

}(window.wp.blocks, window.wp.i18n, window.wp.element, window.wp.blockEditor));
