<?php

$url = 'https://getsoapy.com/.well-known/apple-developer-merchantid-domain-association';

// This seems most reliable, if cURL is installed
if (function_exists('curl_version')) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $result = curl_exec($ch);
    curl_close($ch);

    if ($result) {
        echo $result;
        exit;
    }
}

// This is the most basic, but could be disabled
try {
    $result = file_get_contents($url);
    if ($result) {
        echo $result;
        exit;
    }
} catch (\Exception $e) {
    // Sigh
}

// You'd think this was best, but it hard errors locally
try {
    $request  = wp_remote_get($url, array(
        'user-agent' => 'wp-plugin'
    ));

    $result = wp_remote_retrieve_body($request);
    if ($result) {
        echo $result;
        exit;
    }
} catch (\Exception $e) {
    // Urgh
}

echo 'Sorry, it was not possible to load the verification file';
