<?php

function getsoapy_add_scripts()
{
    wp_enqueue_script(
        'getsoapy_embed',
        'https://embed.getsoapy.com/embed.js',
        [],
        date('Ymd'),
        true
    );

    $business_id = esc_attr(get_option('getsoapy_business_id', ''));
    $hide_fields = esc_attr(get_option('getsoapy_hide_fields', null));
    $styles = esc_attr(get_option('getsoapy_styles', null));
    $extra_options = json_decode(get_option('getsoapy_plugin_options', '{}'), true);

    $options = json_encode(
        array_merge(
            [
                'hideFields' => $hide_fields ?: null,
                'defaultStyles' => $styles ?: null,
                'loadStyles' => !get_option('getsoapy_disable_styles'),
                'completeInSections' => !!get_option('getsoapy_quote_in_pages', true),
                'floatingActionButton' => !!get_option('getsoapy_show_fab', true),
            ],
            $extra_options ?: []
        )
    );

    if ($business_id !== '') {
        wp_add_inline_script('getsoapy_embed', "getSoapy.init('{$business_id}', {$options});");
    }
}
add_action('wp_enqueue_scripts', 'getsoapy_add_scripts');

function getsoapy_preload_styles()
{
    if (!get_option('getsoapy_disable_styles')) {
        echo '<link rel="preload" as="style" href="https://embed.getsoapy.com/styles.css">' . PHP_EOL;
    }

    $business_id = esc_attr(get_option('getsoapy_business_id', ''));
    if ($business_id) {
        echo '<link rel="preload" as="fetch" href="https://getsoapy.com/api/embed/start?businessId=' . $business_id . '">' . PHP_EOL;
    }
}
add_action('wp_head', 'getsoapy_preload_styles');

add_shortcode('getsoapy_quote', 'getsoapy_quote');
function getsoapy_quote($atts = [], $content = null)
{
    return '<div class="getsoapy" id="getsoapy-quote">getSoapy Quote Widget. Javascript is required.</div>';
}

add_shortcode('getsoapy_pay', 'getsoapy_pay');
function getsoapy_pay($atts = [], $content = null)
{
    return '<div class="getsoapy" id="getsoapy-pay">getSoapy Payment Widget. Javascript is required.</div>';
}

add_shortcode('getsoapy_portal', 'getsoapy_portal');
function getsoapy_portal($atts = [], $content = null)
{
    return '<div class="getsoapy" id="getsoapy-portal">getSoapy Customer Portal. Javascript is required.</div>';
}
